CREATE OR ALTER procedure GET_USL_RECORDS (
    ID_STATTALON integer,
    SPEZFILTER char(1),
    SPEZ char(3),
    DIAGNOS char(7))
returns (
    NYS varchar(200),
    O_S char(1),
    K_USL char(16),
    D_OKAZ date,
    PAID smallint,
    DIAG char(7),
    ZYSV numeric(12,2),
    VOZ char(1),
    OMS char(1),
    OMS_VZ char(1),
    OMS_D char(1),
    M char(1),
    F char(1),
    UR char(1),
    DOC_K char(10),
    KODU integer,
    ST_O numeric(12,2),
    NM_SP char(45),
    OBR integer)
as
declare variable TERR char(4);
declare variable ID_REPORT integer;
declare variable ID_FYSMANUAL integer;
declare variable D_OS char(7);
begin
    select stattalon.terr, d_os, id_report, stattalon.was_child
    from stattalon where id_stattalon = :id_stattalon
        into :terr, :d_os, :id_report, :voz;

    select id_fysmanual from report where id_report = :id_report
        into :id_fysmanual;

    if (terr = '1137') then
    begin
        if (:DIAGNOS = :d_os) then
        begin
            for select o_s, k_usl_mz, d_okaz, paid, diag, usl_od.usl_code,
                    nozolog.oms, nozolog.oms_vz, nozolog.oms_d, nozolog.m, nozolog.f, fys2006.nys, usl_od.urov,
                    usl_od.k_vr, usl_od.kol, spez2006.name_st, usl_od.st_obr, usl_od.obr
                from USL_OD, NOZOLOG, FYS2006, FFIOV, spez2006
                where USL_OD.id_stattalon = :id_stattalon
                and USL_OD.diag = NOZOLOG.code
                and fys2006.idfysmanual = :id_fysmanual
                and USL_OD.k_usl_mz = fys2006.kod_us_mz
                and FFIOV.id_report = :id_report
                and ((FFIOV.shfiov = USL_OD.k_vr) or
                ((FFIOV.shfiov = USL_OD.k_ss) and (USL_OD.k_vr='')))
                and ffiov.spez = spez2006.sh_st
                and ((:spezfilter = '-') or (:spez = FFIOV.spez))
                into :o_s, :k_usl, :d_okaz, :paid, :diag, :zysv,
                    :oms, :oms_vz, :oms_d, :m, :f, :nys, :ur, :doc_k, :kodu,
                    :nm_sp, :st_o, :obr do
            begin
                suspend;
            end
        end
        else
        begin
            for select o_s, k_usl_mz, d_okaz, paid, diag, usl_od.usl_code,
                    nozolog.oms, nozolog.oms_vz, nozolog.oms_d, nozolog.m, nozolog.f,
                    fys2006.nys, usl_od.urov,
                    usl_od.k_vr, usl_od.kol, spez2006.name_st, usl_od.st_obr, usl_od.obr
                from USL_OD, NOZOLOG, fys2006, FFIOV, spez2006
                where USL_OD.id_stattalon = :id_stattalon
                and USL_OD.diag = NOZOLOG.code
                and USL_OD.diag = :DIAGNOS
                and fys2006.idfysmanual = :id_fysmanual
                and usl_od.k_usl_mz = fys2006.kod_us_mz
                and FFIOV.id_report = :id_report
                and ((FFIOV.shfiov = USL_OD.k_vr) or
                ((FFIOV.shfiov = USL_OD.k_ss)and (USL_OD.k_vr='')))
                and ffiov.spez = spez2006.sh_st
                and ((:spezfilter = '-') or (:spez = FFIOV.spez))
                into :o_s, :k_usl, :d_okaz, :paid, :diag, :zysv,
                    :oms, :oms_vz, :oms_d, :m, :f, :nys, :ur, :doc_k, :kodu,
                    :nm_sp, :st_o, :obr do
            begin
                suspend;
            end
        end
    end
    else
    begin
        if (:DIAGNOS = :d_os) then
        begin
            for select o_s, k_usl_mz, d_okaz, paid, diag, usl_od.usl_code,
                    nozolog.oms, nozolog.oms_vz, nozolog.oms_d, nozolog.m, nozolog.f,
                    fys2006.nys, usl_od.urov,
                    usl_od.k_vr, usl_od.kol, spez2006.name_st, usl_od.st_obr, usl_od.obr
                from USL_OD, NOZOLOG, FYS2006, FFIOV, spez2006
                where USL_OD.id_stattalon = :id_stattalon
                and USL_OD.diag = NOZOLOG.code
                and FYS2006.idfysmanual = :id_fysmanual
                and USL_OD.k_usl_mz = FYS2006.kod_us_mz
                and FFIOV.id_report = :id_report
                and ((FFIOV.shfiov = USL_OD.k_vr) or
                ((FFIOV.shfiov = USL_OD.k_ss)and (USL_OD.k_vr='')))
                and ffiov.spez = spez2006.sh_st
                and ((:spezfilter = '-') or (:spez = FFIOV.spez))
                into :o_s, :k_usl, :d_okaz, :paid, :diag, :zysv,
                    :oms, :oms_vz, :oms_d, :m, :f, :nys, :ur, :doc_k, :kodu,
                    :nm_sp, :st_o, :obr do
            begin
                suspend;
            end              
        end
        else
        begin
            for select o_s, k_usl_mz, d_okaz, paid, diag, usl_od.usl_code,
                    nozolog.oms, nozolog.oms_vz, nozolog.oms_d, nozolog.m, nozolog.f,
                    fys2006.nys, usl_od.urov,
                    usl_od.k_vr, usl_od.kol , spez2006.name_st, usl_od.st_obr, usl_od.obr
                from USL_OD, NOZOLOG, fys2006, FFIOV, spez2006
                where USL_OD.id_stattalon = :id_stattalon
                and USL_OD.diag = NOZOLOG.code
                and USL_OD.diag = :DIAGNOS
                and FYS2006.idfysmanual = :id_fysmanual
                and USL_OD.k_usl_mz = fys2006.kod_us_mz
                and FFIOV.id_report = :id_report
                and ((FFIOV.shfiov = USL_OD.k_vr) or
                ((FFIOV.shfiov = USL_OD.k_ss)and (USL_OD.k_vr = '')))
                and ffiov.spez = spez2006.sh_st
                and ((:spezfilter = '-') or (:spez = FFIOV.spez))
                into :o_s, :k_usl, :d_okaz, :paid, :diag, :zysv,
                    :oms, :oms_vz, :oms_d, :m, :f, :nys, :ur, :doc_k, :kodu,
                    :nm_sp, :st_o, :obr do
            begin
                suspend;
            end
        end
    end
end
